<template>
	<iframe
		id="matrixIframe"
		ref="elementIframe"
		scrolling="no"
		frameborder="0"
		style="position: relative; width: 100%; min-height: 100%; visibility: hidden;"
		:src="elementUrl"
		allow="camera; microphone" />
</template>

<script>
/* eslint-disable no-unreachable */
/* eslint-disable no-console */
/* eslint-disable no-debugger */

export default {
	name: 'ElementView',
	props: {
		elementUrl: {
			type: String,
			default: '',
		},
		credentials: {
			type: Object,
			default: () => {},
		},
	},
	data() {
		return {
			refreshIntervalId: null,
		}
	},
	async mounted() {
		const iframe = this.$refs.elementIframe
		let win, n

		// authentication
		const postMessageHandler = (event) => {
			console.log('BADGE 13')
			// if(event.origin !== destUrl) return; TODO: pass valid destination url to javascript script
			let data = {}
			try {
				data = JSON.parse(event.data)
				console.log(data)
				/* if (data.status === 'im.vector.notif_count') {
          let title = document.title.replace(/\(.*?\) /, '')
          if (data.msg === 0) {
            console.log('BADGE 13')
            badgeElement.hide()
          } else {
            console.log('BADGE 14')
            title = '(' + data.msg + ') ' + title
            badgeElement
              .text(data.msg)
              .show()
          }
          document.title = title
        } else */ if (data.action === 'im.vector.newLogin') {
					const msg = {
						accessToken: this.credentials.matrix_token,
						homeserverUrl: this.credentials.home_server_url,
						identityServerUrl: this.credentials.identity_server_url,
						userId: this.credentials.matrix_username,
						deviceId: this.credentials.device_id,
						action: 'im.vector.newLogin',
					}
					console.log('postMessageParent: I\'m forcing a new login')
					win.postMessage(JSON.stringify(msg), '*')
					clearInterval(this.refreshIntervalId)
					console.log('BADGE postMessageParent: data received:', event.data)
				}
				console.log('BADGE 33')
				console.log(data)

				if (data.status !== 'im.vector.loading') {
					console.log('BADGE 22')
					clearInterval(this.refreshIntervalId)
					// $('#matrix_loading').hide()
					if (data.status === 'im.vector.error') {
						console.log('BADGE 23')
						console.log('postMessageParent: error! Message is "' + data.msg + '"')
						// $('#matrix_error').show()
					} else {
						console.log('BADGE 24')
						iframe.style.visibility = 'visible'
					}
				}
			} catch (e) {
				console.log('BADGE 25')
				console.log('BADGE postMessageParent: error! Data from rios-chat-web is not a well formatted JSON!')
				console.log(e)

			}
		}

		window.addEventListener('message', postMessageHandler, false)

		iframe.onload = () => {
			// eslint-disable-next-line no-console
			console.log('iframe onload')
			try {
				win = iframe.contentWindow
			} catch (e) {
				win = iframe.contentWindow
			}
			const msg = {
				accessToken: this.credentials.matrix_token,
				homeserverUrl: this.credentials.home_server_url,
				identityServerUrl: this.credentials.identity_server_url,
				userId: this.credentials.matrix_username,
				deviceId: this.credentials.device_id,
				action: (this.credentials.is_new_session) ? 'im.vector.newLogin' : 'im.vector.login',
			}
			win.postMessage(JSON.stringify(msg), '*')

			this.refreshIntervalId = setInterval(() => {
				if (win) {
					// console.log('postMessageParent: sent login request', msg);
					win.postMessage(JSON.stringify(msg), '*')
					n++
					if (n === 1000) {
						clearInterval(this.refreshIntervalId)
					}
				}
			}, 300)
		}
	},
}
</script>
